- [HTTP request](https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/list#body.HTTP_TEMPLATE)
- [Query parameters](https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/list#body.QUERY_PARAMETERS)
- [Request body](https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/list#body.request_body)
- [Response body](https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/list#body.response_body)
  - [JSON representation](https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/list#body.ListCustomBiddingAlgorithmsResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/list#body.aspect)
- [Try it!](https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/list#try-it)

Lists custom bidding algorithms that are accessible to the current user and can be used in bidding stratgies.

The order is defined by the `https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/list#body.QUERY_PARAMETERS.order_by` parameter.

### HTTP request

`GET https://displayvideo.googleapis.com/v4/customBiddingAlgorithms`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Query parameters

| Parameters ||
|---|---|
| `pageSize` | `integer` Requested page size. Must be between `1` and `200`. If unspecified will default to `100`. Returns error code `INVALID_ARGUMENT` if an invalid value is specified. |
| `pageToken` | `string` A token identifying a page of results the server should return. Typically, this is the value of `https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/list#body.ListCustomBiddingAlgorithmsResponse.FIELDS.next_page_token` returned from the previous call to `customBiddingAlgorithms.list` method. If not specified, the first page of results will be returned. |
| `orderBy` | `string` Field by which to sort the list. Acceptable values are: - `displayName` (default) The default sorting order is ascending. To specify descending order for a field, a suffix "desc" should be added to the field name. Example: `displayName desc`. |
| `filter` | `string` Allows filtering by custom bidding algorithm fields. Supported syntax: - Filter expressions are made up of one or more restrictions. - Restrictions can be combined by `AND`. A sequence of restrictions implicitly uses `AND`. - A restriction has the form of `{field} {operator} {value}`. - The `customBiddingAlgorithmType` field must use the `EQUALS (=)` operator. - The `displayName` field must use the `HAS (:)` operator. Supported fields: - `customBiddingAlgorithmType` - `displayName` Examples: - All custom bidding algorithms for which the display name contains "politics": `displayName:"politics"`. - All custom bidding algorithms for which the type is "SCRIPT_BASED": `customBiddingAlgorithmType=SCRIPT_BASED` The length of this field should be no more than 500 characters. Reference our [filter `LIST` requests](https://developers.google.com/display-video/api/guides/how-tos/filters) guide for more information. |
| Required. Identifies which DV360 entity the request is being made within. The LIST request will only return custom bidding algortihm entities that are accessible to the DV360 entity identified within the `accessor`. To perform LIST request, user needs to have permission to the `accessor` entity. The following is a list of mutually exclusive fields. At most one of the fields will be set in a response: ||
| `partnerId` | `string (https://developers.google.com/discovery/v1/type-format format)` The ID of the DV360 partner that has access to the custom bidding algorithm. |
| `advertiserId` | `string (https://developers.google.com/discovery/v1/type-format format)` The ID of the DV360 advertiser that has access to the custom bidding algorithm. |
| End of mutually exclusive fields. ||

### Request body

The request body must be empty.

### Response body

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "customBiddingAlgorithms": [ { object (`https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms#CustomBiddingAlgorithm`) } ], "nextPageToken": string } ``` |

| Fields ||
|---|---|
| `customBiddingAlgorithms[]` | ``object (`https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms#CustomBiddingAlgorithm`)`` The list of custom bidding algorithms. This list will be absent if empty. |
| `nextPageToken` | `string` A token to retrieve the next page of results. Pass this value in the `https://developers.google.com/display-video/api/reference/rest/v4/customBiddingAlgorithms/list#body.QUERY_PARAMETERS.page_token` field in the subsequent call to `ListCustomBiddingAlgorithmsRequest` method to retrieve the next page of results. If this field is null, it means this is the last page. |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/display-video`

For more information, see the [OAuth 2.0 Overview](https://developers.google.com/identity/protocols/OAuth2).